commit 449d25b4f8b8d3bb55a865ebcbec17b39b37c208
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Jul 6 17:56:53 2026 +1000

    depend

commit 0227fe4606ebf86b3f6f9b80af12e171eaa58416
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Jul 6 17:56:10 2026 +1000

    crank version numbers

commit 0210c7cc942ee54bd6a647d5732df9786c4b08d0
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jul 6 07:54:26 2026 +0000

    upstream: openssh-10.4
    
    OpenBSD-Commit-ID: ce7b0749e5139c70410ee92a13d368d7d34262b5

commit 5d04ca6af739b82fd30d84d2783ca802ebfa1192
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jul 6 07:53:30 2026 +0000

    upstream: Fix multiple RFC 4462 (GSSAPIAuthentication) compliance
    
    problems
    
    1) Remove an early failure return for GSSAPI authentication attempts
    made for invalid accounts that yielded different behaviour for
    valid vs invalid accounts.
    
    2) Fix a situation where some GSSAPI requestes were not correctly
    subjected to MaxAuthTries.
    
    3) Fix a moderate pre-authentication resource DoS related to #2.
    
    Add missing logging for error cases.
    
    Report and fixes from Manfred Kaiser, milCERT AT
    
    OpenBSD-Commit-ID: ca0acdd64eea435d6f89534538a9eb404a5629d3

commit e8bdfb151a356d0171fea4194dd205fbb252be23
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jul 6 07:49:58 2026 +0000

    upstream: fix ownership and lifetime of several bits of client
    
    state that need to persist for the life of the connection, especially the
    cached hostkey that was being incorrectly freed early on some paths, possibly
    allowing its use after free.
    
    Reported by Zhenpeng (Leo) Lin from depthfirst.com
    
    OpenBSD-Commit-ID: faaa6ad72e7d69d41fa8b197b606265b7d9bc73f

commit d43ba60c91cb323ca921049b7d43b1908c318454
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jul 6 07:44:48 2026 +0000

    upstream: Fix cases in GSSAPI and keyboard-interactive
    
    authentication where the minimum per-attempt delay was not being enforced.
    
    Reported by Orange Cyberdefense Vulnerability Team
    
    OpenBSD-Commit-ID: c40bd35cc2428fcaccad7a141703c28baa6da01e

commit cf67d46cba77d493152830a108b5f294ee9c5140
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sun Jul 5 02:46:44 2026 +0000

    upstream: void functions should not return anything. Patch from Tim
    
    Rice.
    
    OpenBSD-Commit-ID: bb5021b2b45d9d3f54a012d569872805d107f59c

commit 93d6348ae44491b7542d78c0d55da7130e9db017
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Jul 5 00:16:21 2026 +0000

    upstream: fix inverted test that broke ssh-add with keys on stdin. From
    
    Laurence Tratt
    
    OpenBSD-Commit-ID: bcef522cfa587c7cf035660bb347cff36b65bfbd

commit aab5620a66777afbe9e0939b4961e5751d6e7938
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Jul 3 14:20:02 2026 +1000

    grammar fix; from Daniel O'Connor

commit c123ac1c579212c08c17d927cb8e379d45f9fccb
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Jul 3 14:16:29 2026 +1000

    more config option details in README.privsep

commit 3912be7baa05819c382ce0e5d0ef847c9d80f230
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Jul 3 14:10:16 2026 +1000

    more README.privsep polish

commit f80e6545ee9eb60b3fb8b0097fcc12aad47a54b4
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Jul 3 13:33:16 2026 +1000

    tweak; from dlg@

commit 01ed1c648a2c42e85e73cac3b7647f1cddc4abba
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Jul 3 12:49:26 2026 +1000

    tweak previous

commit 85dcff277e7a5299ec13af12517aefb123b1aa95
Author: Damien Miller <djm@mindrot.org>
Date:   Fri Jul 3 12:31:27 2026 +1000

    revise README.privsep for multi-binary model
    
    This rewrites most of the privsep description to more accurately capture
    recent changes in how sshd managed privilege across its lifecycle,
    including describing the roles of the sshd-session and sshd-auth
    helper binaries.
    
    Also 100% more ASCII art

commit a5ecfdc21864b29ef9a939b9cfe7a2a8ffcdf439
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Jul 2 10:05:43 2026 +1000

    Need clang >= 19 for constexpr in hardened_malloc.

commit c53864fc40045d0413c36a19ca784b1b2f985dd9
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Jun 25 18:43:48 2026 +1000

    Tabs -> spaces.

commit 0a75a95d582028c5ce91f524c20365df9f2515f2
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   Wed Apr 16 15:11:59 2025 +0200

    Provide better error for non-supported private keys
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

commit 654e1a3e5b58029b05f1df0308e7e4d4407b37c2
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Jul 1 01:14:39 2026 +0000

    upstream: more missing mldsa44-ed25519, based on GHPR696 from Loganaden
    
    Velvindron
    
    OpenBSD-Commit-ID: f32e17df54fa66b0e936f1aeb3963f949e4a9bb8

commit 088ca00b8f19a0257b2f869cb828ab75e99ab3a1
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Jul 1 01:08:51 2026 +0000

    upstream: whitespace
    
    OpenBSD-Commit-ID: 730e54174b2182c7011cc87a0fdae595cd9bcc2d

commit 0cdead097bde10712cd0635b5d350c16e07ba52a
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Jul 1 01:06:54 2026 +0000

    upstream: simplify SIGINFO output: remove list of active channels (too
    
    verbose) and just display destination and connection duration; requested
    deraadt@
    
    OpenBSD-Commit-ID: cb36192cd53483f8e452ea91bc42be7bbb2fffa3

commit 55ffd11b88f073662cdf0c8c48fe0800b8a71fc4
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Jul 1 00:52:31 2026 +0000

    upstream: Tighten up the introduction a little:
    
    Mention Match as a conditional directive (previously it only
    mentioned Host)
    
    Try to use consistent language in the introduction to refer to
    configuration directives (previously it used "parameters" and
    "keywords" interchangeably).
    
    Mention that comments may appear at the end of the line too, and that
    whitespace at the beginning/end of lines is not significant.
    
    OpenBSD-Commit-ID: e08f34413eeced47478c14d5005726f9bdd5d80e

commit 8b05bbeb293c5f777915e37e9ed43a06fb8e7614
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Wed Jul 1 00:52:23 2026 +0000

    upstream: Move negative-FD checks to before first use. CID 909998,
    
    ok djm@
    
    OpenBSD-Commit-ID: f0208911d27fd5bd66cd608c7b6fb5a36002d6a5

commit 296393226e4849010516150f3e19dbfc68789503
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Jul 1 00:04:46 2026 +0000

    upstream: ssh -o doesn't support Host or Include options, they are only
    
    valid in the config file. bz3968 from xspielinbox
    
    OpenBSD-Commit-ID: cbecf11f2eea63e3cf6752e9bbe59091ba60cd32

commit fe85df40aed36a49b9883186a123a1435c17f895
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jun 30 23:55:32 2026 +0000

    upstream: mention mldsa44-ed25519 in usage(); based on GHPR695 from
    
    Loganaden Velvindron
    
    OpenBSD-Commit-ID: 4af2400312b6ca232a68a758160ca5c64ca6a168

commit aabe6d25498d9dc69fa21fbb14352fd4b3d5e9fa
Author: tb@openbsd.org <tb@openbsd.org>
Date:   Tue Jun 30 03:42:53 2026 +0000

    upstream: ssherr-libcrypto: avoid use of deprecated
    
    ERR_load_crypto_strings()
    
    Follow regress and use unchecked OPENSSL_init_crypto() because
    ERR_load_crypto_strings() has been deprecated in OpenSSL 1.1.0.
    This call can in principle fail, in which case there's a fallback
    to generic error strings.
    
    There is still use of OpenSSL 3.x-deprecated API in here. That's
    a problem for someone else to solve.
    
    ok djm
    
    OpenBSD-Commit-ID: 3e9dc94caa83b361775b83a92425e858f8680c05

commit dcba967d3f39f89d17634e550e1741b2b91f4c5c
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jun 30 02:30:19 2026 +0000

    upstream: another ruser_name/ruser_group vs attrib_to_stat() ordering
    
    screwup. Coverity CID 910530 via dtucker@
    
    OpenBSD-Commit-ID: d8c4656119f09304e79fcf2ab32299ed68006a29

commit 710cd5abcea22aeddbd5d5d661c224eaa05e47b9
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jun 30 00:10:48 2026 +0000

    upstream: set FD_CLOEXEC on the fds between sftp and its ssh
    
    process, avoids risk of subcommands that write on odd fds breaking the
    connection. GHPR693 from Manuel Einfalt; feedback deraadt@ ok dtucker@
    
    OpenBSD-Commit-ID: 91b12cd66580dab6b3bfe5e507a1a8310c8f9149

commit fa447bd5836f6d1c742c543207a3a6ec2909da75
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jun 30 00:09:01 2026 +0000

    upstream: check key and IV length received in privsep state
    
    transfer exactly match the expected sizes for the selected cipher; partially
    redundant to similar checks in cipher_init(), but nice to be more exact.
    
    GHPR from jmestwa-coder; ok dtucker@
    
    OpenBSD-Commit-ID: d4a9deef194cc44189e835ac59b7b800b9b5c281

commit 23a7c4d1284694f9973ebdae7884cd25d33e5cf8
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jun 29 23:00:00 2026 +0000

    upstream: revert bits that weren't ready for commit yet
    
    OpenBSD-Commit-ID: ee8a219f02db32778444356ad2d93b983a38a704

commit b9d2162e4a919168bbd983fa68663f813b534034
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jun 29 22:56:44 2026 +0000

    upstream: Move user/group name lookup to correct place; coverity
    
    CID 910530 via dtucker@
    
    OpenBSD-Commit-ID: 03ba9f8c720eea38436e4fef4c40814eae1b1fe3

commit 0875a78bb7228986c2e89ef2f5fe041d2ab27ed7
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jun 29 09:14:25 2026 +0000

    upstream: fix ineffective max file size check when loading
    
    blobs/keys from files and add another one on a patch that was not covered by
    the existing ones. From Tess Gauthier via bz3969 and bz3970
    
    OpenBSD-Commit-ID: c0dec6c587853349113df85b6dc528dc15079af0

commit 5d8e42933ab3f1a1c17608c32d680300f5524a99
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jun 29 08:59:31 2026 +0000

    upstream: check strdup() return to avoid NULL deref on failure.
    
    bz3948 from RuiHe-MO
    
    OpenBSD-Commit-ID: 2b1fbfb2e1f3359150feadfdf05acaa1c7d211e8

commit 0eaeddeefa4bd9b1241788b27ed2967ab596c759
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jun 29 08:57:06 2026 +0000

    upstream: s/calloc/xcalloc/ to reduce noise from AI bug detectors
    
    that don't understand context
    
    OpenBSD-Commit-ID: dcef5b1804620f2aed108267bbf5023a81230e14

commit a9cb2e30d3a50ba6a24047d87cd80e4b4a18b5ff
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jun 29 08:48:22 2026 +0000

    upstream: fix "ls -n", which was still displaying user/group names
    
    rather than numeric uids/gids. Based on patch from Tamilan in bz3953
    
    OpenBSD-Commit-ID: 65dd2ecb870b727e872cf9df544f8767426d2cc0

commit 3c3226f79cf4fa1c0436a91768760b92df87ffab
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jun 29 08:21:50 2026 +0000

    upstream: move documentation of the Include directive to near the
    
    start of the options list, alongside that for Match and Host which are
    similar insofar as they all affect configuration parsing rather than altering
    the configuration directly. from xspielinbox via bz3968
    
    OpenBSD-Commit-ID: 1cde8af8d40dbbe3ea49cf56c5d408946c875230

commit ce697f1eaf76a3d8d700894726c7a826af393ed5
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jun 29 08:19:21 2026 +0000

    upstream: mention RefuseConnection, VersionAddendum and
    
    WarnWeakCrypto along with other options. from xspielinbox via bz3968
    
    OpenBSD-Commit-ID: 5d4ef72dc703a74e64175e4611961ea338379d66

commit 849748c6e5d79274020489b03d068361d98ff42f
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jun 29 08:16:46 2026 +0000

    upstream: correct directive name (s/Host/Match) in error message
    
    from xspielinbox via bz3968
    
    OpenBSD-Commit-ID: 3aec5cc9d349bcef12abc951490474f1217b4aeb

commit c8716138281d3dac33c2c7e98615c52d2b606d85
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jun 29 07:56:19 2026 +0000

    upstream: report errors in fill_default_options() properly, based on
    
    GHPR649 by Zoltán Fridrich
    MIME-Version: 1.0
    Content-Type: text/plain; charset=UTF-8
    Content-Transfer-Encoding: 8bit
    
    OpenBSD-Commit-ID: 10137e31df74c3100e3abc7d008b1645ca5b45af

commit d9df26d7e93f76bc5b1c0cbd31cde0af00ccbbc0
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jun 29 07:46:22 2026 +0000

    upstream: don't use deprecated ERR_load_crypto_strings()
    
    GHPR650 from Mike Frysinger
    
    OpenBSD-Regress-ID: bfe86d9be1db4569c091f3d763cba04ddbb86ec0

commit 365522938f7a44df993c38f8a51836bab3628211
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Jun 29 17:21:01 2026 +1000

    don't leak rrset on fail; GHPR681 from metsw24-max
    
    ok dtucker

commit fceb78d14abc710f2bab31f28d321a9bb2476781
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Jun 29 17:18:58 2026 +1000

    check sockaddr length; GHPR681 from metsw24-max
    
    ok dtucker

commit 9d5238f44dda8d9455c085f51f2fb00774f69d38
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Jun 29 17:17:28 2026 +1000

    return result of raise(2); GHPR681 from metsw24-max
    
    ok dtucker

commit fa5416dec1232dc67d979d28942344cdc8086ae6
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Jun 29 17:16:55 2026 +1000

    use size_t for lengths; GHPR681 from metsw24-max
    
    ok dtucker

commit ef6bef31de60b077cb7da954b202d65156fd510e
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Jun 29 17:15:10 2026 +1000

    fix leak of error path; GHPR681 from metsw24-max
    
    ok dtucker

commit 84365594f44423b69392f295f82e9cbcdd8c2640
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jun 29 07:36:37 2026 +0000

    upstream: don't print an error message when trying to load a host
    
    private key when PKCS#11 keys are in use, as these don't need the private
    half on the filesystem. GHPR664 from Ingo Franzki
    
    OpenBSD-Commit-ID: c93352e218cb1b74af04e8dc3a42eddec1f312c0

commit d6a589d3c8530375c2d56bcfb914575a7fcd3715
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jun 29 02:13:05 2026 +0000

    upstream: make ssh-add open it's connection to the agent after it
    
    has finished getopt() processing and not before. This allows the -v flag to
    work properly.
    
    ok jca@
    
    OpenBSD-Commit-ID: b9ac820018875aeb5b43ae2119a70c16a5cd2aef

commit 1cfbed8a131de166d86fbf5ac3245d55046cfab3
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jun 29 02:08:55 2026 +0000

    upstream: Fix bounds checking when signing messages of length
    
    greater than will fit in a size_t. In OpenSSH, messages sizes are bounded by
    SSHBUF_SIZE_MAX so this was unreachable. From Swival scanner.
    
    OpenBSD-Commit-ID: 31ab874abe21a528fa995d78023c5ad9444a31e1

commit c58b363e4f7c10134b583fc92556229bf6c2c16b
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jun 29 01:58:29 2026 +0000

    upstream: fix ECDSA order check for curves with cofactor != 1. All
    
    supported EC curves have cofactor 1, so this is a nop. From Swival scanner
    
    OpenBSD-Commit-ID: 4ae44cc97714fcb6d19fa56714ede56c1ef521e1

commit c1cebbc7c69acfe5df07b4a95e4c32cebc3e105a
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jun 29 01:53:21 2026 +0000

    upstream: avoid situation where sftp_download() could get stuck in
    
    a loop if a broken server repeatedly returned zero length while reading a
    file. Identified by Swival scanner
    
    OpenBSD-Commit-ID: 53f1de5065ff01952d2abb51747c2418ce21cd96

commit 1b39f39657d2e58f8ec57341581a39bbf0be645b
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jun 29 01:47:21 2026 +0000

    upstream: avoid download to server-controlled path when performing
    
    download on the commandline. From Swival scanner
    
    OpenBSD-Commit-ID: d1b2c44305fdfe6d51eed9ecc727e59478bf311f

commit 36480181fa22f98e180b4f9e10203480c0346c78
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Jun 28 23:47:16 2026 +0000

    upstream: resist that return ".." via remote glob during
    
    remote/remote copies, similar to fixes for bz3871 for remote/local copies.
    From Swival scanner
    
    OpenBSD-Commit-ID: c0c20a1b746db55c08e53658bf21ea9405b300a5

commit 8dec7df34b38ea510b5548a020f2664e59700d23
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Jun 28 23:31:28 2026 +0000

    upstream: avoid possible NULL deref; from Swival scanner
    
    OpenBSD-Commit-ID: 62ea8e12b7cddee933596e72f8ab0f7364147c0f

commit 09c2eeb9c8a0f42716d67548c75a6f4870732caa
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jun 26 06:17:13 2026 +0000

    upstream: mention that ssh-keyscan output is only as trustworthy as
    
    the network between it and the SSH server; ok markus@
    
    OpenBSD-Commit-ID: 067845df7e8eb776408de5f23a2e6e7019945834

commit 6f74eb3c56f8dc4886d2bc5b068c5bf82cb6db74
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Thu Jun 25 08:14:47 2026 +1000

    Dropbear master -> main here too.

commit b0894a23a6bcb4f008d119854cb520f0b44b0973
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Jun 24 22:05:05 2026 +1000

    Dropbear's master is now main.

commit aa60cf3f41e89530448a720e08ec31a6d8ffd79e
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Wed Jun 24 11:59:09 2026 +0000

    upstream: Avoid printf("%s", NULL) since it's not guaranteed to be safe
    
    and will segfault on some -portable platforms.
    
    OpenBSD-Commit-ID: b49d588f8becf6363305aac42d7d9660fc7fe3ba

commit 7c70c3d352f7e8f16ed799f03957ee87840da4e6
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Jun 24 19:22:36 2026 +1000

    Fix handling of rh-allow-sha1-signatures on Cygwin
    
    The format of openssl.cnf has changed, so append to it instead of trying
    to insert into it.  Test that openssl can sign RSA with SHA1 before
    proceeding.

commit a4c5d09657860cb8583e4cb176b2396fc8bdb523
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Jun 24 19:05:12 2026 +1000

    Make -j2 for faster builds.

commit 110117accb95fc310a3923115e9316a9748ff6ae
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Jun 24 19:04:48 2026 +1000

    Set CYGWIN at top-level.
    
    The ensures the symlinks created in any step (eg, logs) are native
    symlinks and can be understood by the log upload step.

commit 8058c5bdb507591b79ec926221fbe6fcc296d432
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Jun 24 06:55:12 2026 +0000

    upstream: mention a caveat regarding GSSAPIStrictAcceptorCheck in
    
    some environments
    
    OpenBSD-Commit-ID: aa7158d8f22cb34063c1c2d3cbcf30a9489847c2

commit 87e21b16d033700819a1381b9a2bfa2f8b3a217d
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Jun 24 06:53:57 2026 +0000

    upstream: add some logging to make debugging interactive/bulk
    
    classification mistakes easier next time (though I think we've got them all
    now, really)
    
    OpenBSD-Commit-ID: 5fe3dd4e76ffba787a423e301095d55cf5b0f0dc

commit 162cb8721ca0fdb71aaf00688ac7d59a81fc8d5f
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Wed Jun 24 06:53:11 2026 +0000

    upstream: add a missing channels type for bulk/interactive
    
    classification bz3972; ok dtucker@
    
    OpenBSD-Commit-ID: 9c9442ea14be74877e2c876b1fe9fa20d158dd97

commit 5dac5a9252074fb39da617ffc123830266614a4c
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Wed Jun 24 12:19:53 2026 +1000

    Set build options in /etc/mk.conf once at startup.

commit 512bfedf61129788d680210081e89843858dde85
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Jun 22 12:28:48 2026 +0000

    upstream: Check return values from malloc.
    
    OpenBSD-Regress-ID: 28c8ab94a4fa5d047cec9c865b10bbf3c9ccf6d1

commit e683097d90e4698893c86a6f61c8c994b68cbcc6
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Mon Jun 22 12:08:33 2026 +0000

    upstream: Check return value of sscanf.
    
    OpenBSD-Regress-ID: e06a8c769541b1aa7d663cc8859ddabd93847e81

commit b88165a06c8e195f267909de002450245e60002e
Author: tb@openbsd.org <tb@openbsd.org>
Date:   Sun Jun 21 19:23:56 2026 +0000

    upstream: annotate tm_wday = -1 with /* sentinel for error */ per
    
    timegm(3) manpage
    
    suggested by deraadt
    
    OpenBSD-Commit-ID: 2fa92f0b826f0ab9e5d1cb0b2243b8e2f80951b2

commit 0d08d384a6783d3f3bc5a01d10015f527e0792ba
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jun 19 05:26:04 2026 +0000

    upstream: remove cipher_set_keyiv() as nothing uses it from
    
    Loganaden Velvindron
    
    OpenBSD-Commit-ID: 2a6636388028e6f7aa6837d6484a369f3d9c0818

commit 10715f25c40f5f7c670c341fadc52fbe1935db08
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon Jun 22 21:28:58 2026 +1000

    Output Actions allowlist for uploading to Github.

commit 01404fa5da11ed08c6ebecd09aaa3ebfbd79f206
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Mon Jun 22 19:00:15 2026 +1000

    Add script to lookup and pin Actions to hashes.
    
    Update recently changed Cygwin Actions and pin remaining unpinned ones.

commit faa646a9bf6c8d0ec2d8a52dcd155979c8f7eb8e
Author: El Mehdi Abenhazou <mehdiananas007@gmail.com>
Date:   Wed Jun 3 02:02:31 2026 +0100

    ci: pin upstream.yml actions to full commit SHAs
    
    Signed-off-by: El Mehdi Abenhazou <mehdiananas007@gmail.com>

commit 983096a7b27eaf789b5ceb321867d4511ba779c3
Author: El Mehdi Abenhazou <mehdiananas007@gmail.com>
Date:   Wed Jun 3 02:02:30 2026 +0100

    ci: pin GitHub Actions to full commit SHAs
    
    Pinning actions/checkout, actions/upload-artifact, and
    cygwin/cygwin-install-action to their full commit SHA instead of
    mutable branch/tag references (main, master).
    
    Using mutable refs means a compromised or malicious update to the
    action repository could silently alter the workflow behavior.
    Pinning to SHA makes the exact version immutable and auditable.
    
    Signed-off-by: El Mehdi Abenhazou <mehdiananas007@gmail.com>

commit 0d156d385e1e9c31bd5fb3652cf620a1f51c9b19
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Jun 16 22:27:10 2026 +0000

    upstream: Factor out hex2bin into a shared helper function.
    
    Replace sscanf %hhx (which is C99) with plain %x for better compatibility
    in -portable. ok djm@
    
    OpenBSD-Regress-ID: 4d30bb27ffdf2154f1a9f2317df18d256717b300

commit b9d134a0b16a1810e9bbfac5bc687f5dbc75e7fa
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Jun 16 10:58:42 2026 +0000

    upstream: Use awk instead of cut to help -portable.
    
    Some platforms have size limits on cut.
    
    OpenBSD-Regress-ID: fe871e8ed43fd92efb0df76f61c5cc9c5429ea82

commit 60978ddb08701d409c8236765caab10d1acded1b
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Jun 16 09:00:47 2026 +0000

    upstream: Include stdarg.h for va_list (needed for xmalloc.h).
    
    OpenBSD-Regress-ID: 34a6d5db48eec77f92f868093dfa0bfc10ae4622

commit 3de49e0d281ac7efb766f06eb2942ae147f64bbb
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Tue Jun 16 08:15:35 2026 +0000

    upstream: Include stdlib.h for malloc/free and sort headers.
    
    OpenBSD-Regress-ID: 4f5f427b131f5d6b32ed107b9bef098153f768ce

commit 61ca39c119108e95f94e3d914aa6fd79d99e288d
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Jun 16 18:16:32 2026 +1000

    Remove check for OpenSSL w/out AES192/256.
    
    This was the case for some old Solaris versions, but the support for it
    has long been removed from our compat layer so there's no point checking
    for it.

commit f433c09931665b1139dc9ef0951d3540242e4a38
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jun 15 06:36:52 2026 +0000

    upstream: use different strategy to check whether keys are present or
    
    absent in the agent; helps some -portable tests on platforms that have stupid
    grep(1)
    
    OpenBSD-Regress-ID: 0cee7ecc437eee7471dc6ccc3b3a0c2b60c1ad2d

commit 860ed04158f2c6dc870ea7c98c23dcafc7772dd4
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jun 15 06:24:20 2026 +0000

    upstream: avoid use of paste(1); helps portable
    
    OpenBSD-Regress-ID: ce3ad41b34af9fc16af83e4711a62231ee52a95c

commit f5f02aafe89971d838d7fbc6b0cf240cee4d48bc
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Jun 15 12:53:53 2026 +1000

    another place mldsa-ed25519 keys need deactivation

commit 1d6064d25fed17b184ead85ef6fddec1a2132c53
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Mon Jun 15 01:55:44 2026 +0000

    upstream: fix multiple problems with testing hostkey types that are not
    
    enabled by default.
    
    1) Add all hostkey types in the "multiple hostkeys" subtest.
      Previously known_hosts was accidentally clobbered, causing
      only the last added hostkey type to be used.
    2) Explicitly enable the hostkey types under test via
      HostKeyAlgorithms
    
    OpenBSD-Regress-ID: 8f12d18b79b5cc8a748e187a0e95529cd85a9dcc

commit ebdaacf4907033af1cbf1fef593436081dcd67a7
Author: Damien Miller <djm@mindrot.org>
Date:   Mon Jun 15 11:43:52 2026 +1000

    bring back mlkem768x25519-sha256 stubs
    
    should fix C89 compile

commit b35a6a153f4164a56174e4795d4384867349e9aa
Author: Damien Miller <djm@mindrot.org>
Date:   Sun Jun 14 20:32:12 2026 +1000

    don't build ML-KEM/ML-DSA code with <C99 compilers

commit 1c46384db91a724a214ce96297d64c7ea9274a4c
Author: Damien Miller <djm@mindrot.org>
Date:   Sun Jun 14 20:24:25 2026 +1000

    include includes.h

commit ea505c83ecae67c66c020f03b964cf471055191e
Author: Damien Miller <djm@mindrot.org>
Date:   Sun Jun 14 18:56:31 2026 +1000

    provide a htobe32() replacement

commit 8e0cb471774e39a308e41cf5890823dfb418fd5b
Author: Damien Miller <djm@mindrot.org>
Date:   Sun Jun 14 15:02:24 2026 +1000

    hook up new regress/unittests/crypto

commit 5a474d1bf338a895ce5973883c2f79d766f7dd42
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Jun 14 04:08:05 2026 +0000

    upstream: unit and regression tests for composite PQ ML-DSA44/Ed25519
    
    keys.
    
    Includes a new unittests/crypto test that tests basic functionality
    of the underlying crypto primitives against public test vectors
    
    OpenBSD-Regress-ID: 4463b2e8adec391efa24a953f3c911b72892ca80

commit db1bad146ff3e9aa8e2e8eac926b185870417b2f
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Jun 14 04:16:19 2026 +0000

    upstream: make crypto_sign_ed25519_keypair_from_seed non-static.
    
    The new ML-DSA/ed25519 code needs it
    
    OpenBSD-Commit-ID: 48d00a2094bca8e422494aaa76105c708837436e

commit 81ca1451bf94edd9533c4f6787130f2396219049
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sun Jun 14 03:59:34 2026 +0000

    upstream: Add experimental support for a composite post-quantum
    
    signature scheme that combines ML-DSA 44 and Ed25519 using the construction
    specified in draft-ietf-lamps-pq-composite-sigs. There's also an early draft
    documenting use of the integration of this scheme into SSH as
    draft-miller-sshm-mldsa44-ed25519-composite-sigs
    
    This scheme is not enabled by default. To you use, you'll need
    to add it to HostKeyAlgorithms, PubkeyAcceptedAlgorithms, etc.
    Keys may be generated using "ssh-keygen -t mldsa44-ed25519".
    
    The ML-DSA implementation comes from libcrux. Thanks to
    Jonas Schneider-Bensch and Jonathan Protzenko for their work to
    make this available.
    
    Consensus is that it's time to get this in to allow people to
    experiment with it.
    
    feedback markus@ tb@ logan@ deraadt@
    
    OpenBSD-Commit-ID: 85f2d41e3d3374b4e8c28a45a7c92f153c4489e2

commit b7e552138b8861469295e33e1457040e3f747d06
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Sat Jun 13 00:37:13 2026 +0000

    upstream: when replying to a "query" SSH_AGENTC_EXTENSION request,
    
    don't append an SSH_AGENT_SUCCESS to the reply to the query. bz3967 ok
    dtucker@
    
    OpenBSD-Commit-ID: b51418708096e26dbf73a0c1d3cb49b7352bc899

commit 5af8f3f290bd892352eb007866c066b7bf4a4385
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sun Jun 7 08:50:17 2026 +0000

    upstream: Make crypto_sign_ed25519_keypair_from_seed()
    
    static to prevent compiler warnings since it's only used within ed25519.c.
    
    OpenBSD-Commit-ID: cf8b1e8f364167eb1766f646cc18a40f32242991

commit 5ebfdf3afaede40b1f0f9b5874ba53bf9d21d6d5
Author: dtucker@openbsd.org <dtucker@openbsd.org>
Date:   Sun Jun 7 08:21:07 2026 +0000

    upstream: Import updated moduli
    
    OpenBSD-Commit-ID: c3081ccc6e4c1cb21e68c36f5a92e6d9f09e70b3

commit 47af21eb8d480c0f368a629ab58e31b993ed28f2
Author: Damien Miller <djm@mindrot.org>
Date:   Sun Jun 7 09:56:41 2026 +1000

    sync fmt_scaled.c with OpenBSD upstream
    
    Notably picks up this commit:
    
    revision 1.24
    date: 2026/06/06 23:49:25;  author: djm;  state: Exp;  lines: +28 -12;  commitid: oznzDs0MaUT3FEqO;
    rearrange scan_scaled(3) ordering of multiplications and divisions
    to better preserve accuracy for large exponents. From metsw24-max
    via https://github.com/openssh/openssh-portable/pull/671/
    
    ok tb@

commit e9916c44c1324ab9ab022719e4df08a390a83014
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jun 5 08:53:07 2026 +0000

    upstream: pass >9 commandline arguments to the internal-sftp server,
    
    previously they were silently dropped; reported by Steve Caffrey ok deraadt@
    
    OpenBSD-Commit-ID: ee6cd5430a3ca027c3223af54b58ad3cc7ccd624

commit 70d7044a966a541d9df6002fbeb62d005555cc78
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jun 5 08:48:43 2026 +0000

    upstream: avoid truncation of pathnames headed to lstat() for
    
    systems where PATH_MAX is not the actual max; reported by sahvx655-wq via
    GHPR688
    
    OpenBSD-Commit-ID: fcbeeff99d857f2f3916ad06570fa05fc38b0f07

commit 37bf1431aa0f5e746f9ae0247f52da1e8b5758d6
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Fri Jun 5 06:51:02 2026 +0000

    upstream: rename a variable to be more accurate
    
    OpenBSD-Commit-ID: bf277f2832125eb40ac2c9fa3ea66e31214f2131

commit 7763a38bc2595be50baf1d72b19bf4720e41e8e3
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Thu Jun 4 04:26:51 2026 +0000

    upstream: add signature malleability and pubkey validity checks to
    
    ed25519 verification (SSH doesn't depend on these properties) Pointed out by
    Soatok Dreamseeker
    
    Add an explicit-seed variant of the keygen function.
    
    feedback / "looks fine" tb@
    
    OpenBSD-Commit-ID: 2a71926bfda24628cf34a88357f44a790e338d5d

commit 65c6ac0a82f8bc3faf5a18fef36112fec1b54fc2
Author: djm@openbsd.org <djm@openbsd.org>
Date:   Tue Jun 2 06:18:27 2026 +0000

    upstream: refer to RFC9987 instead of I-D
    
    OpenBSD-Commit-ID: 6b273c50c2aa818b9144b8d9ab568c4239023297

commit c9ebebb22fa50ca50bd036599028d7e09f841c3f
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Jun 2 21:57:42 2026 +1000

    Reformat setup_ci command line.
    
    This prevents setup_ci from running twice on Cygwin due to different
    parsing of the command line since on Windows it's run via Powershell.

commit 60343e46d5f8b79137a14d2ea5c85bf0b7359cc1
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Jun 2 22:20:44 2026 +1000

    Fix search for awk formatter.
    
    AC_PATH_PROG only takes a single binary to look for, AC_PATH_PROGS is
    what's needed for more than one.  Looks like an error by me in 285546b.

commit 7e5590cf8ff732a946629b6f766c7a2c9b2ac425
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Jun 2 18:49:02 2026 +1000

    Replace shell-level timeout with dedicated command.
    
    It turns out the systems we run this workflow on all have timeout(1),

commit 41bb8c1823a337dca1b027a1e5c560f6a5fc4acc
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Jun 2 18:10:25 2026 +1000

    Add a single retry to VM package install steps.
    
    These are potentially flaky due to network issues, so hopefully this
    will reduce the number of manual retries needed.

commit 14d88d4da7fb72d94239049d76c7651723b1a3d9
Author: Darren Tucker <dtucker@dtucker.net>
Date:   Tue Jun 2 17:44:12 2026 +1000

    Add includes.h for compat functions.
    
    Fixes build on at least old AIX.
